<?php
namespace Teknisa\FIS\Modules\Acessorias\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Fis45000DesissBHFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function callExportacaoProcedure($params) {
        $procedure = new StoredProcedure($this->connection, 'DES_ISS_BH');
        
        $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $params["CDEMPRESA"], Param::PARAM_TYPE_STR));    
        $procedure->addParam(new Param('P_CDINSCMUNI', Param::PARAM_INPUT   , $params["CDINSCMUNI"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINICIAL', Param::PARAM_INPUT, $params["DTINICIAL"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $params["DTFINAL"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_VERSAO', Param::PARAM_INPUT, $params["VERSAO"], Param::PARAM_TYPE_STR));    
        $procedure->addParam(new Param('P_CDLIVROMAG', Param::PARAM_INPUT, $params["CDLIVROMAG"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSEQARQMAG', Param::PARAM_INPUT   , $params["NRSEQARQMAG"], Param::PARAM_TYPE_STR));

    
        $procedure->execute();
    }

    public function deleteDesissBH($params) {
        // Query a ser executada.
        $sql = "DELETE FROM ARQMAGNETICO WHERE NRSEQARQMAG = :NRSEQARQMAG AND NRORG = :NRORG";

        // Prepara o statement da query para execução.
        $statement = $this->connection->prepare($sql);

        // Executa o statement com os paràmetros passados.
        $statement->execute($params);
    }

    public function getDesissBHData($params) {
        // Query a ser executada.
        //$sql = "SELECT T.NRSEQARQMAG, T.NRORDREGARQ, T.DSREGARQMAG , T.SQUENCIAL FROM( SELECT NRSEQARQMAG, NRORDREGARQ, DSREGARQMAG as DSREGARQMAG , ROWNUM as SQUENCIAL FROM ( SELECT NRSEQARQMAG, NRORDREGARQ, DSREGARQMAG as DSREGARQMAG FROM ARQMAGNETICO WHERE NRSEQARQMAG = :NRSEQARQMAG AND NRORG = :NRORG ORDER BY NRORDREGARQ, SUBSTR(DSREGARQMAG,1,17)))T";
        $sql = "SELECT T.NRSEQARQMAG, T.NRORDREGARQ, T.DSREGARQMAG, T.SQUENCIAL
                FROM
                (
                    SELECT NRSEQARQMAG, NRORDREGARQ, DSREGARQMAG as DSREGARQMAG, ROWNUM as SQUENCIAL
                    FROM
                    (
                        SELECT NRSEQARQMAG, NRORDREGARQ, DSREGARQMAG as DSREGARQMAG
                        FROM ARQMAGNETICO
                        WHERE NRSEQARQMAG = :NRSEQARQMAG
                        AND   NRORG = :NRORG
                        ORDER BY NRORDREGARQ, SUBSTR(DSREGARQMAG,1,17)
                    )
                )T";
    
        // Prepara o statement da query para execução.
        $statement = $this->connection->prepare($sql);

        // Executa o statement com os paràmetros passados.
        $statement->execute($params);

        // Executa um fetch no primeiro dado, retornando-o.
        return $statement->fetchAll();
    }

}