<?php

namespace App\Service;

use App\Exception;

class RequestService {
    
    private $util;
    
    public function __construct (\App\Util\Util $util) {
        $this->util = $util;
    }
    
    public function doRequest($url, $verb, $requestHeaders = [], $params = null, $user = null, $pass = null, $delete = false){
        $ch = curl_init();
        
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $requestHeaders);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_PROXY, "http://192.168.122.121:3128");
        curl_setopt($ch, CURLOPT_PROXYUSERPWD, "");
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $verb);
        curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        curl_setopt($ch, CURLOPT_FAILONERROR, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        
        if($params !== null){
            curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
        }
        
        if($user !== null && $pass !== null){
            curl_setopt($ch, CURLOPT_USERPWD, "$user:$pass");
            curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
        }
        
        $initTime = microtime(1);
        $response = curl_exec($ch);
        $endTime  = microtime(1);
        
        $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        
        //Is not a job deletion request
        if($delete === false){
            if (!empty(curl_error($ch)) || (stripos($response, "<html>"))) {
    
                $fileName = date("H-i-s") . ".txt";
                $this->util->writeLog('network', $fileName, $this->util->formatNetworkError([
                    'eventTime' => date("d/m/Y H:i:s"),
                    'header'    => $requestHeaders,
                    'url'       => $url,
                    'method'    => $verb,
                    'params'    => $params,
                    'httpCode'  => $httpCode,
                    'error'     => curl_error($ch),
                    'response'  => $response
                ]));
    
                throw new Exception\NetworkException("Não foi possível completar a requisição");
            }
            
            return $response;
        } 
        
        //Is a job deletion request
        else{
            return $httpCode;
        }
    }
}