/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_HIPD                                                     */
/* Tabela : HISTPADR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 07/01/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_HIPD
BEFORE INSERT OR UPDATE OR DELETE
ON HISTPADR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUHIPD := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDHISTPADR,0) <> NVL(:NEW.CDHISTPADR,0)) OR
         (NVL(:OLD.DSHISTPADR,0) <> NVL(:NEW.DSHISTPADR,0)) THEN
         :NEW.DTULTATUHIPD := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('HISTPADR', '', 'CDHISTPADR='||:OLD.CDHISTPADR||';', SYSDATE);
   END IF;

END;
/

ALTER TABLE HISTPADR MODIFY DTULTATUHIPD DEFAULT SYSDATE
/
