IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'LOG_DIH_PRESDIET' and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER LOG_DIH_PRESDIET
  GO
CREATE TRIGGER LOG_DIH_PRESDIET
ON PRESDIET
FOR INSERT, UPDATE, DELETE

AS

DECLARE  @V_USUARIO    VARCHAR(40);
DECLARE  @V_TIPO       VARCHAR(1);
DECLARE  @V_ITPESQ     VARCHAR(40);
DECLARE  @V_DESC       VARCHAR(300);
DECLARE  @V_DTOPER     DATETIME;
DECLARE  @V_DSIP       VARCHAR(15);
DECLARE  @V_DSUSUARIO  VARCHAR(15)
DECLARE  @V_DSRDM      VARCHAR(20);
DECLARE  @V_DSMETODO   VARCHAR(30);
DECLARE  @V_DSOPERADOR VARCHAR(12);

/* Variveis do cursor */
DECLARE @V_IDCOMANDO       VARCHAR(1);
DECLARE @V_OLD_CDFILIAL    VARCHAR(4);
DECLARE @V_NEW_CDFILIAL    VARCHAR(4);
DECLARE @V_OLD_CDPACIENTE  VARCHAR(12);
DECLARE @V_NEW_CDPACIENTE  VARCHAR(12);
DECLARE @V_OLD_DTPRESDIET  DATETIME;
DECLARE @V_NEW_DTPRESDIET  DATETIME;
DECLARE @V_OLD_CDDIETPAD   VARCHAR(4);
DECLARE @V_NEW_CDDIETPAD   VARCHAR(4);
DECLARE @V_OLD_CDNIASNUTR  VARCHAR(3);
DECLARE @V_NEW_CDNIASNUTR  VARCHAR(3);


BEGIN
   SET  @V_TIPO = '0';
   SET  @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   EXEC WEBTUNNING @V_DSIP,
                   @V_DSUSUARIO,
                   @V_DSRDM,
                   @V_DSMETODO,
                   @V_DSOPERADOR;
   DECLARE C_DADOS CURSOR FOR

     SELECT
       'D' IDCOMANDO,
       CDFILIAL,
       CDFILIAL,
       CDPACIENTE,
       CDPACIENTE,
       DTPRESDIET,
       DTPRESDIET,
       CDDIETPAD,
       CDDIETPAD,
       CDNIASNUTR,
       CDNIASNUTR
     FROM
       DELETED
     WHERE
       0 = (SELECT COUNT(*) FROM INSERTED)

     UNION ALL

     SELECT
       'U' IDCOMANDO,
       DELETED.CDFILIAL,
       INSERTED.CDFILIAL,
       DELETED.CDPACIENTE,
       INSERTED.CDPACIENTE,
       DELETED.DTPRESDIET,
       INSERTED.DTPRESDIET,
       DELETED.CDDIETPAD,
       INSERTED.CDDIETPAD,
       DELETED.CDNIASNUTR,
       INSERTED.CDNIASNUTR
     FROM
       INSERTED,
       DELETED
     WHERE
       INSERTED.CDFILIAL    = DELETED.CDFILIAL   AND
       INSERTED.CDPACIENTE  = DELETED.CDPACIENTE AND
       INSERTED.DTPRESDIET  = DELETED.DTPRESDIET

     UNION ALL

     SELECT
       'I' IDCOMANDO,
       CDFILIAL,
       CDFILIAL,
       CDPACIENTE,
       CDPACIENTE,
       DTPRESDIET,
       DTPRESDIET,
       CDDIETPAD,
       CDDIETPAD,
       CDNIASNUTR,
       CDNIASNUTR
     FROM
       INSERTED
     WHERE
       0 = (SELECT COUNT(*) FROM DELETED);

   OPEN C_DADOS;
   FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                @V_OLD_CDFILIAL,
                                @V_NEW_CDFILIAL,
                                @V_OLD_CDPACIENTE,
                                @V_NEW_CDPACIENTE,
                                @V_OLD_DTPRESDIET,
                                @V_NEW_DTPRESDIET,
                                @V_OLD_CDDIETPAD,
                                @V_NEW_CDDIETPAD,
                                @V_OLD_CDNIASNUTR,
                                @V_NEW_CDNIASNUTR;


   WHILE (@@FETCH_STATUS = 0) BEGIN

     IF @V_IDCOMANDO = 'D' /* Deleting */ BEGIN
        IF @V_OLD_CDFILIAL <> NULL BEGIN
           SET @V_DESC = @V_DESC + 'Fili=' + @V_OLD_CDFILIAL;
        END;
        IF @V_OLD_CDPACIENTE <> NULL BEGIN
           SET @V_DESC = @V_DESC + ' CodPaci=' + @V_OLD_CDPACIENTE;
        END;
        IF @V_OLD_DTPRESDIET <> NULL BEGIN
           SET @V_DESC = @V_DESC + ' DtPresc=' + CONVERT(VARCHAR,@V_OLD_DTPRESDIET,103)+' '+CONVERT(VARCHAR,@V_OLD_DTPRESDIET,8);
        END;
        IF @V_OLD_CDDIETPAD <> NULL BEGIN
           SET @V_DESC = @V_DESC + ' CodDiet=' + @V_OLD_CDDIETPAD;
        END;
        IF @V_OLD_CDNIASNUTR <> NULL BEGIN
           SET @V_DESC = @V_DESC + ' NivelNutr=' + @V_OLD_CDNIASNUTR;
        END;

        SET @V_DESC = @V_DESC + ' Rdm='   + @V_DSRDM;
        SET @V_DESC = @V_DESC + ' Mtodo='   + @V_DSMETODO;
        SET @V_DESC = @V_DESC + ' Ip='       + @V_DSIP;
        SET @V_DESC = @V_DESC + ' Usurio='  + @V_DSUSUARIO;
        SET @V_DESC = @V_DESC + ' Operador=' + @V_DSOPERADOR;

        SET @V_TIPO         = '3';
        SET @V_ITPESQ       = @V_OLD_CDFILIAL+@V_OLD_CDPACIENTE+CONVERT(VARCHAR,@V_OLD_DTPRESDIET,103);

     END
     ELSE BEGIN
        IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
          IF (@V_OLD_CDFILIAL     <> @V_NEW_CDFILIAL)    OR
             (@V_OLD_CDPACIENTE   <> @V_NEW_CDPACIENTE)  OR
             (@V_OLD_DTPRESDIET   <> @V_NEW_DTPRESDIET)  OR
             (@V_OLD_CDDIETPAD    <> @V_NEW_CDDIETPAD)   OR
             (@V_OLD_CDNIASNUTR   <> @V_NEW_CDNIASNUTR)  BEGIN
            SET @V_TIPO        = '2';
            SET @V_ITPESQ      = @V_OLD_CDFILIAL+@V_OLD_CDPACIENTE+CONVERT(VARCHAR,@V_NEW_DTPRESDIET,103);
          END;
        END
        ELSE BEGIN
          /* Inserting */
          SET @V_TIPO        = '1';
          SET @V_ITPESQ      = @V_NEW_CDFILIAL+@V_NEW_CDPACIENTE+CONVERT(VARCHAR,@V_NEW_DTPRESDIET,103);
        END;

        IF @V_NEW_CDFILIAL <> NULL  BEGIN
           SET @V_DESC = @V_DESC + 'Fili=' + @V_NEW_CDFILIAL;
        END;
        IF @V_NEW_CDPACIENTE <> NULL BEGIN
            SET @V_DESC = @V_DESC + ' CodPaci=' + @V_NEW_CDPACIENTE;
        END;
        IF @V_NEW_DTPRESDIET <> NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtPresc=' + CONVERT(VARCHAR,@V_NEW_DTPRESDIET,103)+' '+CONVERT(VARCHAR,@V_NEW_DTPRESDIET,8);
        END;
        IF @V_NEW_CDDIETPAD <> NULL BEGIN
            SET @V_DESC = @V_DESC + ' CodDiet=' + @V_NEW_CDDIETPAD;
        END;
        IF @V_NEW_CDNIASNUTR <> NULL BEGIN
            SET @V_DESC = @V_DESC + ' NivelNutr=' + @V_NEW_CDNIASNUTR;
        END;

        SET @V_DESC = @V_DESC + ' Rdm='      + @V_DSRDM;
        SET @V_DESC = @V_DESC + ' Mtodo='   + @V_DSMETODO;
        SET @V_DESC = @V_DESC + ' Ip='       + @V_DSIP;
        SET @V_DESC = @V_DESC + ' Usurio='  + @V_DSUSUARIO;
        SET @V_DESC = @V_DESC + ' Operador=' + @V_DSOPERADOR;


     END;

     IF @V_TIPO <> '0' BEGIN
       IF (@V_DESC <> NULL) BEGIN
          IF (@V_USUARIO <> NULL) BEGIN
             SET @V_DTOPER = GETDATE();

             INSERT INTO LOGOPERA
                (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                 DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
             VALUES
                ('PRESDIET', @V_DTOPER, @V_USUARIO, @V_TIPO, @V_ITPESQ, SUBSTRING(@V_DESC, 1, 300),
                 @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_DSOPERADOR, ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL));
          END;
       END;
     END;

     FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                  @V_OLD_CDFILIAL,
                                  @V_NEW_CDFILIAL,
                                  @V_OLD_CDPACIENTE,
                                  @V_NEW_CDPACIENTE,
                                  @V_OLD_DTPRESDIET,
                                  @V_NEW_DTPRESDIET,
                                  @V_OLD_CDDIETPAD,
                                  @V_NEW_CDDIETPAD,
                                  @V_OLD_CDNIASNUTR,
                                  @V_NEW_CDNIASNUTR;
   END;

   CLOSE      C_DADOS;
   DEALLOCATE C_DADOS;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_DIH_PRESDIET','4.11.083';
GO

