var Fis20600_RelatoriosCustomizavelImpostosProdutoMapaApuracao_Controller = function(templateManager, ZhFilterPreferences) {

    this.IMPOSTO_FEDERAL   = 'F';
    this.IMPOSTO_ESTADUAL  = 'E';
    this.IMPOSTO_MUNICIPAL = 'M';
    
    this.openFilter = function(widget){
        var rowsToSet = {};
        rowsToSet.IDENTRSAIDOP = "E";
        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };
    
    this.filtraTipoOperacao = function(widget){
        widget.getField('CDTIPOOPER').dataSourceFilter[0].value = widget.getField('IDENTRSAIDOP').value();
        widget.getField('CDTIPOOPER').reload();
    };
    
    this.filterMapaApuracao = function(widget, field){
        var mapa = widget.getField('NMMAPAAPUR');
        mapa.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDINSCESTA': filter.value = (widget.currentRow.CDINSCESTA) ? widget.currentRow.CDINSCESTA : null;
                    break;
                case 'CDINSCMUNI': filter.value = (widget.currentRow.CDINSCMUNI) ? widget.currentRow.CDINSCMUNI : null;
                    break;
            }
        });
        if (field){
            mapa.readOnly = (field.value()) ? false : true;
        }
    };
    
    this.preparaFiltroImpostoMapaApuracao = function(widget, preference){
          var filterRow = preference.FILTER_ROW;
      //  var  filterRow = args.appliedFilter.FILTER_ROW;
        var filtro = [];
          filtro = [
            {
                'name': 'FILIAL',
                'operator': '=',
                'value': (filterRow.CDFILIAL && filterRow.CDFILIAL != '') ? filterRow.CDFILIAL : null
            },
			{
                'name': 'CDIMPOSTO',
                'operator': '=',
                'value': (filterRow.CDIMPOSTO)
            },
			{
                'name': 'TIPO',
                'operator': '=',
                'value': (filterRow.IDENTRSAIDOP && filterRow.IDENTRSAIDOP != '') ? filterRow.IDENTRSAIDOP : null
            },
            {
                'name': 'CDTIPOOPER',
                'operator': '=',
                'value': (filterRow.CDTIPOOPER && filterRow.CDTIPOOPER != '') ? filterRow.CDTIPOOPER : null
            },
            {
                'name': 'DTFIMPERIODO',
                'operator': '=',
                'value': (filterRow.DTFINAL.substr(0, 10))
            },
            {
                'name': 'CDINSCMUNI',
                'operator': '=',
                'value': (filterRow.CDINSCMUNI && filterRow.CDINSCMUNI != '') ? filterRow.CDINSCMUNI : null
            },
            {
                'name': 'DTINIPERIODO',
                'operator': '=',
                'value': (filterRow.DTINICIAL.substr(0, 10))
            },
            {
                'name': 'CDEMPRESA',
                'operator': '=',
                'value': (filterRow.CDEMPRESA && filterRow.CDEMPRESA != '') ? filterRow.CDEMPRESA : null
            },
            {
                'name': 'CDINSCESTA',
                'operator': '=',
                'value': (filterRow.CDINSCESTA && filterRow.CDINSCESTA != '') ? filterRow.CDINSCESTA : null
            }
        ];
        
        widget.dataSourceFilter = filtro;
        
        delete filterRow.CDFILIAL;
        delete filterRow.IDENTRSAIDOP;
        delete filterRow.DTINICIAL;
        delete filterRow.DTFINAL;
        
        
        widget.reload();
        preference.CUSTOM_FILTER_ROW = {};
        
        
    };
    
    this.removeFieldsClausulaWhere = function(widget, preference, valuesCustomFilter){
        var filtrosRemoviveis = ['NRSEQUMAPAPU', 'NMTIPOOPER', 'NMFILIAL', 'SGESTADO'];
        var dataSourceFilter = widget.dataSourceFilter;
        for (var i = dataSourceFilter.length - 1; i >= 0; i--) {
            if (filtrosRemoviveis.includes(dataSourceFilter[i].name)){
	        	dataSourceFilter.splice(i, 1);
	        }
        }
        preference.CUSTOM_FILTER_ROW = Util.clone(preference.FILTER_ROW);
        for (var key in preference.CUSTOM_FILTER_ROW) {
            if (filtrosRemoviveis.includes(key)){
                delete preference.CUSTOM_FILTER_ROW[key];
            }
            if (valuesCustomFilter.hasOwnProperty(key)){
                preference.CUSTOM_FILTER_ROW[key] = valuesCustomFilter[key];
            }
        }
    };
    
    this.validaCompetenciaSobreImposto = function(widget){
        var empresa = widget.currentRow.CDEMPRESA;
        var imposto = widget.currentRow.CDIMPOSTO;
        var fieldMapa = widget.getField('NMMAPAAPUR');
        var inscricaoEstadual = widget.getField('CDINSCESTA');
        var inscricaoMunicipal = widget.getField('CDINSCMUNI');
        if (empresa && imposto) {
            fieldMapa.value(null);
            this.setValuesFilter(fieldMapa, widget);
            inscricaoEstadual.dataSourceFilter[0].value = widget.currentRow.CDEMPRESA;
            inscricaoMunicipal.dataSourceFilter[0].value = widget.currentRow.CDEMPRESA;
            if (widget.currentRow.IDORGARRECADNFE == this.IMPOSTO_FEDERAL){
                inscricaoEstadual.readOnly     = true;
                inscricaoMunicipal.readOnly    = true;
                inscricaoEstadual.validations  = {};
                inscricaoMunicipal.validations = {};
                widget.currentRow.CDINSCESTA   = null;
                widget.currentRow.CDINSCMUNI   = null;
                fieldMapa.readOnly             = false;
                fieldMapa.clearValue();
            }else if (widget.currentRow.IDORGARRECADNFE == this.IMPOSTO_ESTADUAL){
                inscricaoEstadual.readOnly     = false;
                inscricaoEstadual.validations  = {'required': true};
                inscricaoMunicipal.readOnly    = true;
                inscricaoMunicipal.validations = {};
                widget.currentRow.CDINSCMUNI   = null;
                fieldMapa.readOnly             = true;
                fieldMapa.clearValue();
            }else if (widget.currentRow.IDORGARRECADNFE == this.IMPOSTO_MUNICIPAL){
                inscricaoEstadual.readOnly     = true;
                inscricaoEstadual.validations  = {};
                inscricaoMunicipal.readOnly    = false;
                inscricaoMunicipal.validations = {'required': true};
                widget.currentRow.CDINSCESTA   = null;
                fieldMapa.readOnly             = true;
                fieldMapa.clearValue();
            }  
        } else {
            fieldMapa.readOnly = true;
            widget.currentRow.NMMAPAAPUR = null;
            widget.currentRow.NRSEQUMAPAPU = null;
            widget.currentRow.DTINIPERIODO = null;
            widget.currentRow.DTFIMPERIODO = null;
            inscricaoEstadual.readOnly     = true;
            inscricaoEstadual.validations  = {};
            inscricaoMunicipal.readOnly    = true;
            inscricaoMunicipal.validations = {};
            widget.currentRow.CDINSCESTA   = null;
            widget.currentRow.CDINSCMUNI   = null;
        }
        this.filterMapaApuracao(widget);
    };
    
    this.setValuesFilter = function(field, widget){
        field.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDEMPRESA': filter.value = widget.currentRow.CDEMPRESA;
                    break;
                case 'CDIMPOSTO': filter.value = widget.currentRow.CDIMPOSTO;
                    break;
            }
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('Fis20600_RelatoriosCustomizavelImpostosProdutoMapaApuracao_Controller', Fis20600_RelatoriosCustomizavelImpostosProdutoMapaApuracao_Controller);
});